Тема: Хлопці, допоможіть будь ласка :(

Привіт.

*BRAVO*  *BRAVO*  *BRAVO* Допопможіть, будь ласка *BRAVO*  *BRAVO*  *BRAVO*

Переді мною стоїть завдання під'єднати сервіс https://kanboard.org до телеграму, а саме щоб можна було прослідковувати які задачі, таски і сабтаски є у користувача, щоб користувач міг через телеграм стартувати і зупиняти таймер на той чи інший сабтаск, отримувати оповіщення якщо були отриманні нові таски, сабтаски і задачі від іншої людини,оповіщення який дедлайн у тебе сьогодні, оповіщення що у користувача по дедлайну завтра.

Документацію телеграму і канборда прочитала.

Проблеми у наступному:

1. Є сертифікат до https до канборду, але не пропускає:

import requests

requests.get('https://board.rgray.io', verify='/Users/Katty/Desktop/certificate.pem')

видає помилку:

Traceback (most recent call last):
  File "/Library/Frameworks/Python.framework/Versions/3.7/lib/python3.7/site-packages/requests/packages/urllib3/util/ssl_.py", line 267, in ssl_wrap_socket
    context.load_verify_locations(ca_certs)
ssl.SSLError: unknown error (_ssl.c:4053)

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/Library/Frameworks/Python.framework/Versions/3.7/lib/python3.7/site-packages/requests/adapters.py", line 370, in send
    timeout=timeout
  File "/Library/Frameworks/Python.framework/Versions/3.7/lib/python3.7/site-packages/requests/packages/urllib3/connectionpool.py", line 544, in urlopen
    body=body, headers=headers)
  File "/Library/Frameworks/Python.framework/Versions/3.7/lib/python3.7/site-packages/requests/packages/urllib3/connectionpool.py", line 341, in _make_request
    self._validate_conn(conn)
  File "/Library/Frameworks/Python.framework/Versions/3.7/lib/python3.7/site-packages/requests/packages/urllib3/connectionpool.py", line 761, in _validate_conn
    conn.connect()
  File "/Library/Frameworks/Python.framework/Versions/3.7/lib/python3.7/site-packages/requests/packages/urllib3/connection.py", line 238, in connect
    ssl_version=resolved_ssl_version)
  File "/Library/Frameworks/Python.framework/Versions/3.7/lib/python3.7/site-packages/requests/packages/urllib3/util/ssl_.py", line 269, in ssl_wrap_socket
    raise SSLError(e)
requests.packages.urllib3.exceptions.SSLError: unknown error (_ssl.c:4053)

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/Users/Katty/Documents/all/coding/python/kanboard_tgbot/test2.py", line 3, in <module>
    requests.get('https://board.rgray.io', verify='/Users/MillerProduction/Desktop/certificate.pem')
  File "/Library/Frameworks/Python.framework/Versions/3.7/lib/python3.7/site-packages/requests/api.py", line 69, in get
    return request('get', url, params=params, **kwargs)
  File "/Library/Frameworks/Python.framework/Versions/3.7/lib/python3.7/site-packages/requests/api.py", line 50, in request
    response = session.request(method=method, url=url, **kwargs)
  File "/Library/Frameworks/Python.framework/Versions/3.7/lib/python3.7/site-packages/requests/sessions.py", line 465, in request
    resp = self.send(prep, **send_kwargs)
  File "/Library/Frameworks/Python.framework/Versions/3.7/lib/python3.7/site-packages/requests/sessions.py", line 573, in send
    r = adapter.send(request, **kwargs)
  File "/Library/Frameworks/Python.framework/Versions/3.7/lib/python3.7/site-packages/requests/adapters.py", line 431, in send
    raise SSLError(e, request=request)
requests.exceptions.SSLError: unknown error (_ssl.c:4053)

або видає іншу помилку:

<urlopen error [SSL: CERTIFICATE_VERIFY_FAILED] certificate verify failed: unable to get local issuer certificate (_ssl.c:1056)>


2. Коли відключаю https і залишаю http kanboard не реагує на задачі які я ставлю - проходить без помилок, але дій не здійснює навіть не зважаючи що використовую юзера jsonrpc (найголовнішого) з правильним API:

from kanboard import Kanboard

kb = Kanboard("https://board.rgray.io/jsonrpc.php", "jsonrpc", "API")


project_id = kb.create_project(name="PythonTest")
kb.add_project_user(project_id=project_id, user_id=123, role='project-manager');

task_id = kb.create_task(project_id=project_id, title="My task title")


ну а з телеграм ботом і як завантажувати на хост мій код розібралась  *YAHOO*

залишилось тільки розібратись з протоколами https і kanboard  :-X

2

Re: Хлопці, допоможіть будь ласка :(

З unknown error хай неодружені допомагають; а unable to get local issuer certificate означає, що в Python не налаштовані сертифікати. Якщо у вас MacOS (шляхи трохи натякають, що це так), то ось вам детальна інструкція: https://www.dev2qa.com/how-to-fix-pytho … in-mac-os/
А надалі пишіть, яка у вас система. Вам це 10 секунд, а тим, хто допомагає, може кілька хвилин зекономити.

Подякували: leofun01, ostap34PHP2

3

Re: Хлопці, допоможіть будь ласка :(

У мене Macbook Air

koala написав:

З unknown error хай неодружені допомагають; а unable to get local issuer certificate означає, що в Python не налаштовані сертифікати. Якщо у вас MacOS (шляхи трохи натякають, що це так), то ось вам детальна інструкція: https://www.dev2qa.com/how-to-fix-pytho … in-mac-os/
А надалі пишіть, яка у вас система. Вам це 10 секунд, а тим, хто допомагає, може кілька хвилин зекономити.

4

Re: Хлопці, допоможіть будь ласка :(

Всеодно не працює :(
можливо requests не вірно ввожу якось чи можливо інші запити потрібно використовувати?

5

Re: Хлопці, допоможіть будь ласка :(

tak,ya-divchuna написав:

Всеодно не працює :(
можливо requests не вірно ввожу якось чи можливо інші запити потрібно використовувати?

Цілком можливо.

6

Re: Хлопці, допоможіть будь ласка :(

фото принад будуть? тому що якщо ні, то я теж дівчина

Говоріть українською! Живіть українською! Відчувайте українською!
Подякували: leofun011

7

Re: Хлопці, допоможіть будь ласка :(

FakiNyan написав:

фото принад будуть? тому що якщо ні, то я теж дівчина

Це ви так морально нас готуєте до показу своїх принад? *CRAZY*

py -3 -m pip install git+https://github.com/snoack/python-goto
∩⍴○⌈⍴⍺/∧\∨/⊢○ ⌿⍀⍴⌊
Подякували: tak,ya-divchuna1

8

Re: Хлопці, допоможіть будь ласка :(

P.Y. написав:
FakiNyan написав:

фото принад будуть? тому що якщо ні, то я теж дівчина

Це ви так морально нас готуєте до показу своїх принад? *CRAZY*

я ж не дівчина, поки що

Говоріть українською! Живіть українською! Відчувайте українською!

9

Re: Хлопці, допоможіть будь ласка :(

FakiNyan написав:

фото принад будуть? тому що якщо ні, то я теж дівчина

FakiNyan написав:

я ж не дівчина, поки що

Вже дівчина. :) Фото ж не було.

tak,ya-divchuna написав:

Коли відключаю https і залишаю http

Не могли б ви пояснити, що ви маєте на увазі.

Робіть що хочете - людина створена вільною
Подякували: tak,ya-divchuna1

10

Re: Хлопці, допоможіть будь ласка :(

FakiNyan написав:

фото принад будуть? тому що якщо ні, то я теж дівчина


а я бачу тебе аніме порно з розуму таки зводить

11

Re: Хлопці, допоможіть будь ласка :(

varkon написав:
FakiNyan написав:

фото принад будуть? тому що якщо ні, то я теж дівчина

FakiNyan написав:

я ж не дівчина, поки що

Вже дівчина. :) Фото ж не було.

tak,ya-divchuna написав:

Коли відключаю https і залишаю http

Не могли б ви пояснити, що ви маєте на увазі.


на вебсайті kanboard відключаю сертифікацію і роблю сайт не захищеним

12

Re: Хлопці, допоможіть будь ласка :(

tak,ya-divchuna написав:
FakiNyan написав:

фото принад будуть? тому що якщо ні, то я теж дівчина


а я бачу тебе аніме порно з розуму таки зводить

то зветься - хентай

Говоріть українською! Живіть українською! Відчувайте українською!
Подякували: Betterthanyou1

13

Re: Хлопці, допоможіть будь ласка :(

tak,ya-divchuna написав:

на вебсайті kanboard відключаю сертифікацію і роблю сайт не захищеним

давайте все ж уточнимо, що ми говоримо про одне й теж.
Я правильно зрозумів, що ви на своєму сервері/хостінгу - встановили та розвернули канбоард та налаштували https?
Якщо так - то чи віддає ваш сервер взагалі сторінки через захищене з'єднання? Судячи з усього проблема саме тут.

Робіть що хочете - людина створена вільною
Подякували: leofun011

14

Re: Хлопці, допоможіть будь ласка :(

varkon написав:
tak,ya-divchuna написав:

на вебсайті kanboard відключаю сертифікацію і роблю сайт не захищеним

давайте все ж уточнимо, що ми говоримо про одне й теж.
Я правильно зрозумів, що ви на своєму сервері/хостінгу - встановили та розвернули канбоард та налаштували https?
Якщо так - то чи віддає ваш сервер взагалі сторінки через захищене з'єднання? Судячи з усього проблема саме тут.

так, також отримала файл сертифікату формату .pem

якщо заходити в канборд на свій сервер стандартно через браузер, то працює без проблем
вичитала документацію вздовж і поперек - https://docs.kanboard.org/en/1.2.8/api/index.html , всеодно не можу знайти відповідь і рішення :(

Подякували: leofun011

15

Re: Хлопці, допоможіть будь ласка :(

varkon написав:
tak,ya-divchuna написав:

на вебсайті kanboard відключаю сертифікацію і роблю сайт не захищеним

давайте все ж уточнимо, що ми говоримо про одне й теж.
Я правильно зрозумів, що ви на своєму сервері/хостінгу - встановили та розвернули канбоард та налаштували https?
Якщо так - то чи віддає ваш сервер взагалі сторінки через захищене з'єднання? Судячи з усього проблема саме тут.


зараз пробую:

import requests

r=requests.get('https://server/jsonrpc.php')
r.verify='/Users/Katty/Documents/all/coding/python/kanboard_tgbot/certificate.pem'



from kanboard import Kanboard

kb = Kanboard("https://server/jsonrpc.php", "jsonrpc", "api_token")

project_id = kb.create_project(name="My project")

task_id = kb.create_task(project_id=project_id, title="My task title")

видає помилку:

kanboard.exceptions.KanboardClientException: <urlopen error [SSL: CERTIFICATE_VERIFY_FAILED] certificate verify failed: unable to get local issuer certificate (_ssl.c:1056)>

якщо окремо проводити:

import requests

r=requests.get('https://server/jsonrpc.php')
r.verify='/Users/Katty/Documents/all/coding/python/kanboard_tgbot/certificate.pem'

проходить без помилок

16 Востаннє редагувалося LoganRoss (06.08.2019 12:22:55)

Re: Хлопці, допоможіть будь ласка :(

Проблема може бути в Python 3.6 (якщо він у вас) який на OSX не має сертифікатів і не може валідувати будь-які SSL з'єднання.
Поки бачу наступні варіанти:
1. Встановити пакет certifi
Інфу можна знайти в readme - /Applications/Python\ <version>/ReadMe.rtf

pip install certifi
/Applications/Python\ 3.6/Install\ Certificates.command

2. Не верифікувати SSL з'єднання. Пропоную створити новий SSL контекст без верифікації сертифікатів.

UPD. Бачу koala вже пропонував вам перший варіант і він не спрацював. Пробуйте другий.

Because tomorrow may be gone.
Подякували: leofun01, varkon2